import es
import gamethread
import random
import popuplib

####--Addon Info(Do not touch)--####
info = es.AddonInfo()
info.name        = "Dominating for CS:Source"
info.version     = "2.0.0"
info.author      = "TheBash"
info.url         = "http://addons.eventscripts.com/addons/view/dominating"
info.basename    = "dominating"
info.description = "Gives CS:Source the 'dominating' functionality from TF2, with a few extra twists!"

####--Dominating Level Control--####
dom_ranges = {                                  #Set this to a dictionary of ranges (as many ranges as you want)
    3: "dominated",
    6: "obliterated",
    10: "totally pwned",
    20: "made useless"
}

####--Dominating Reset Control--####
dom_reset_on_map_change = True                  #If True, will reset all dominations on a map change
dom_reset_on_team_change = True                 #If True, will reset dominations on a player if they change teams
dom_reset_on_disconnect = True                  #If True, will reset dominations on a player if they disconnect

####--Dominating Popup Control--####
dom_popup_frequency = 3                         #Set the popups to show up every 'x' rounds
dom_popup_top_value = 5                         #Sets the number of entries to show in the best/most dominations popups
dom_popup_show_cmd = "!domshow"                 #Sets the say command to set popups to show (per player basis)
dom_popup_hide_cmd = "!domhide"                 #Sets the say command to set popups to hide (per player basis)
dom_popup_mydoms_cmd = "!mydom"                 #Sets the say command to show personal dominatons popup (per player basis)

####--Dominating Sound Control--####
dom_use_sounds = False                          #If True, will use sounds
dom_nemesis_sound = "tf2sounds/tf2_nemesis.mp3" #Set this to the sound/music to use when a nemesis is made
dom_revenge_sound = "tf2sound/tf2_revenge.mp3"  #Set this to the sound/music to use when a revenge is made
dom_taunts = [                                  #Set this to a list of sounds to use as taunts (as many taunts as you want)
    "tf2sounds/taunts/taunts1.mp3",
    "tf2sounds/taunts/taunts2.mp3",
    "tf2sounds/taunts/taunts3.mp3",
    "tf2sounds/taunts/taunts4.mp3",
    "tf2sounds/taunts/taunts5.mp3",
    "tf2sounds/taunts/taunts6.mp3",
    "tf2sounds/taunts/taunts7.mp3",
    "tf2sounds/taunts/taunts8.mp3",
    "tf2sounds/taunts/taunts9.mp3",
    "tf2sounds/taunts/taunts10.mp3",
    "tf2sounds/taunts/taunts11.mp3",
    "tf2sounds/taunts/taunts12.mp3",
    "tf2sounds/taunts/taunts13.mp3",
    "tf2sounds/taunts/taunts14.mp3",
    "tf2sounds/taunts/taunts15.mp3",
    "tf2sounds/taunts/taunts16.mp3"
]
dom_sound_music_volume = 0.9                    #Set the volume of the musics (0.0 - 1.0)
dom_sound_taunt_volume = 1.0                    #Set the volume of the taunts (0.0 - 1.0)
dom_sound_mute_cmd = "!dommute"                 #Sets the say command to set sounds to mute (per player basis)
dom_sound_unmute_cmd = "!domunmute"             #Sets the say command to set sounds to unmute (per player basis)

####--DO NOT EDIT BELOW THIS LINE!--####

dominations = {}
domination_counts = {}
domination_records = {}
hidden = {}
muted = {}

adverts = ["#green[DOM]#default Want to see your current domination status? Just type#green " + dom_popup_mydoms_cmd + "#default.",
    "#green[DOM]#default Want to get rid of the dominating popups? Just type#green " + dom_popup_hide_cmd + "#default.",
    "#green[DOM]#default Want to get the dominating popups back? Just type#green " + dom_popup_show_cmd + "#default."]

for domination in dom_ranges:
    adverts.append("#green[DOM]#default Being#green " + dom_ranges[domination] + "#default by someone? That means they have killed you#lightgreen " + str(domination) + " times in a row#default.")
    
if dom_use_sounds:
    adverts.append("#green[DOM]#default Want to get rid of the dominating sounds? Just type#green " + dom_sound_mute_cmd + "#default.")
    adverts.append("#green[DOM]#default Want to get the dominating sounds back? Just type#green " + dom_sound_unmute_cmd + "#default.")

first_range = -1
for dom_range in dom_ranges:
    if dom_range < first_range or first_range == -1:
        first_range = dom_range

dom_round_c = 0

dom_popup = None

def register_downloads():
    es.stringtable("downloadables", "sound/" + dom_nemesis_sound)
    es.stringtable("downloadables", "sound/" + dom_revenge_sound)
    for taunt in dom_taunts:
        es.stringtable("downloadables", "sound/" + taunt)

def load():
    es.set("dominating_version",info.version)
    es.makepublic("dominating_version")
    
    if not es.exists('saycommand', dom_popup_mydoms_cmd):
        es.regsaycmd(dom_popup_mydoms_cmd, "dominating/show_your_dominations", 'Shows your dominations')

    if not es.exists('saycommand', dom_popup_hide_cmd):
        es.regsaycmd(dom_popup_hide_cmd, "dominating/hide_popups", 'Hide popups')

    if not es.exists('saycommand', dom_popup_show_cmd):
        es.regsaycmd(dom_popup_show_cmd, "dominating/show_popups", 'Show popups')

    random.seed()

    if dom_use_sounds:
        if not es.exists('saycommand', dom_sound_mute_cmd):
            es.regsaycmd(dom_sound_mute_cmd, "dominating/mute_sounds", 'Mute sounds')
    
        if not es.exists('saycommand', dom_sound_unmute_cmd):
            es.regsaycmd(dom_sound_unmute_cmd, "dominating/unmute_sounds", 'Unmute sounds')
        
        register_downloads()
        
def unload():
    global dominations
    global domination_counts
    global domination_records
    dominations.clear()
    domination_counts.clear()
    domination_records.clear()
    es.unregsaycmd(dom_popup_mydoms_cmd)
    es.unregsaycmd(dom_popup_hide_cmd)
    es.unregsaycmd(dom_popup_show_cmd)
    
    if dom_use_sounds:
        es.unregsaycmd(dom_sound_mute_cmd)
        es.unregsaycmd(dom_sound_unmute_cmd)

def es_map_start(event_var):
    global dominations
    global domination_counts
    global domination_records
    if dom_reset_on_map_change:
        dominations.clear()
        domination_counts.clear()
        domination_records.clear()
        
    if dom_use_sounds:
        register_downloads()
        
def player_team(event_var):
    global dominations
    global dom_reset_on_team_change
    if dom_reset_on_team_change:
        for key in dominations.keys():
            if event_var['userid'] in key.split('<'):
                del dominations[key]

def player_disconnect(event_var):
    global dominations
    global hidden
    global muted
    if event_var['userid'] in hidden.keys():
        del hidden[event_var['userid']]
    if event_var['userid'] in muted.keys():
        del muted[event_var['userid']]
    if dom_reset_on_disconnect:
        for key in dominations.keys():
            if event_var['userid'] in key.split('<'):
                del dominations[key]

def round_start(event_var):
    global dom_round_c
    global dom_popup_frequency
    dom_round_c = (dom_round_c + 1) % (dom_popup_frequency * 3)
    
    if dom_round_c == 0:
        gamethread.delayed(1.0, show_current_dominations)
    
    if dom_round_c == dom_popup_frequency:
        gamethread.delayed(1.0, show_most_dominations)
        
    if dom_round_c == dom_popup_frequency * 2:
        gamethread.delayed(1.0, show_best_dominations)
        
    es.msg("#multi", adverts[random.randint(0, len(adverts) - 1)])

def play_taunt():
    if dom_use_sounds:
        number = random.randint(0, len(dom_taunts))
        for ply in es.getUseridList():
            if not ply in muted.keys():
                es.playsound(ply, dom_taunts[number], dom_sound_taunt_volume)
            
def play_sound(sound_name):
    if dom_use_sounds:
        for ply in es.getUseridList():
            if not ply in muted.keys():
                es.playsound(ply, sound_name, dom_sound_music_volume)
            
def player_death(event_var):
    global dominations
    global domination_counts
    global domination_records

    centermess = ''
    str1 = event_var['userid'] + '<' + event_var['attacker']
    str2 = event_var['attacker'] + '<' + event_var['userid']
    if str1 in dominations.keys():
        dominations[str1] += 1
        if str2 in dominations.keys():
            if dominations[str2] >= first_range: 
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['attacker']) + ' got revenge on#green ' + es.getplayername(event_var['userid']) + '#default!')
                play_sound(dom_revenge_sound)
                centermess = es.getplayername(event_var['attacker']) + ' got revenge on ' + es.getplayername(event_var['userid']) + '!'              
            del dominations[str2]
        
        if dominations[str1] >= first_range:
            if str1 in domination_records.keys():
                if dominations[str1] > domination_records[str1]:
                    domination_records[str1] = dominations[str1]
            else:
                domination_records[str1] = dominations[str1]
                
        for dom_range in dom_ranges:
            if dominations[str1] == dom_range:
                if dom_range == first_range:
                    if str1 in domination_counts.keys():
                        domination_counts[str1] += 1
                    else:
                        domination_counts[str1] = 1
                play_sound(dom_nemesis_sound)
                if es.getplayerteam(event_var['userid']) == es.getplayerteam(event_var['attacker']):
                    es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['userid']) + ' is being#lightgreen back-stabbed#default by#green ' + es.getplayername(event_var['attacker']) + '#default!')
                    centermess = es.getplayername(event_var['userid']) + ' is being back-stabbed by ' + es.getplayername(event_var['attacker']) + '!'              
                    es.tell(event_var['userid'], '#multi', '#green[DOM] Your teammate is back-stabbing you!')
                    es.tell(event_var['userid'], '#multi', '#green[DOM] They will be punished for their sins!')
                    es.tell(event_var['attacker'], '#multi', '#green[DOM] You are back-stabbing!')
                    es.tell(event_var['attacker'], '#multi', '#green[DOM] For this you will be punished with death!')
                    gamethread.delayed(1.0, es.sexec, (event_var['attacker'], 'kill'))
                    del dominations[str1]
                else:
                    gamethread.delayed(1.6, play_taunt)
                    es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['userid']) + ' is being#lightgreen ' + dom_ranges[dom_range] + '#default by#green ' + es.getplayername(event_var['attacker']) + '#default!')
                    centermess = es.getplayername(event_var['userid']) + ' is being ' + dom_ranges[dom_range] + ' by ' + es.getplayername(event_var['attacker']) + '!'
                    
                    if dom_range == first_range:              
                        es.tell(event_var['userid'], '#multi', '#green[DOM] You have a#lightgreen new nemesis!')
                        
                    es.tell(event_var['userid'], '#multi', '#green[DOM] Get your revenge on#lightgreen ' + es.getplayername(event_var['attacker']) + '#green now!!')


    else:
        dominations[str1] = 1
        if str2 in dominations.keys():
            if dominations[str2] >= first_range:
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['attacker']) + ' got revenge on#green ' + es.getplayername(event_var['userid']) + '#default!')
                play_sound(dom_revenge_sound)
                centermess = es.getplayername(event_var['attacker']) + ' got revenge on ' + es.getplayername(event_var['userid']) + '!'              
            del dominations[str2]
    
    if centermess != '':
        gamethread.delayed(0.1, es.centermsg, centermess)
        gamethread.delayed(1.1, es.centermsg, centermess)
        gamethread.delayed(2.1, es.centermsg, centermess)
        gamethread.delayed(3.1, es.centermsg, centermess)
        gamethread.delayed(4.1, es.centermsg, centermess)

def show_current_dominations():
    global hidden
    global dom_popup
    global dominations
    
    if popuplib.exists('dom_popup'):
        popuplib.delete('dom_popup')

    dom_popup = popuplib.create('dom_popup')
    dom_popup.addline("Current Dominations")
    dom_popup.addline(" ")
    
    key_list = getsortkey(dominations)
    
    count = 0 
    for key in key_list:
        split_key = key.split('<')
        if dominations[key] >= first_range:
            count += 1
            dom_popup.addline(es.getplayername(split_key[1]) + " is dominating " + es.getplayername(split_key[0]) + " (" + str(dominations[key]) + ")")    
    if count == 0:
        dom_popup.addline("No dominations")
    
    for ply in es.getUseridList():
        if not ply in hidden.keys():
            dom_popup.send(ply)
            gamethread.delayed(5.0, dom_popup.unsend, ply)
    
def show_your_dominations():
    global dom_popup
    global dominations
    
    user = es.getcmduserid()
    
    if popuplib.exists('dom_popup'):
        popuplib.delete('dom_popup')
    
    dom_popup = popuplib.create('dom_popup')
    dom_popup.addline("Your Dominations")

    key_list = getsortkey(dominations)
    count = 0 
    for key in key_list:
        split_key = key.split('<')
        if dominations[key] >= first_range and str(user) == split_key[1]:
            if es.getplayername(split_key[0]) != 0:
                count += 1
                dom_popup.addline(es.getplayername(split_key[0]) + " (" + str(dominations[key]) + ")")
                
    if count == 0:
        dom_popup.addline("No dominations")
        
    dom_popup.addline(" ")
    dom_popup.addline("Your Nemesis'")

    count = 0 
    for key in key_list:
        split_key = key.split('<')
        if dominations[key] >= first_range and str(user) == split_key[0]:
            if es.getplayername(split_key[1]) != 0:
                count += 1
                dom_popup.addline(es.getplayername(split_key[1]) + " (" + str(dominations[key]) + ")")
                
    if count == 0:
        dom_popup.addline("No nemesis'")
    
    dom_popup.send(user)
    gamethread.delayed(5.0, dom_popup.unsend, user)
    
def show_most_dominations():
    global hidden
    global dom_popup
    global domination_counts
    
    if popuplib.exists('dom_popup'):
        popuplib.delete('dom_popup')
    
    dom_popup = popuplib.create('dom_popup')
    dom_popup.addline("Most Dominations")
    dom_popup.addline(" ")
    
    key_list = getsortkey(domination_counts)
    count = 0
    for key in key_list:
        split_key = key.split('<')
        if es.getplayername(split_key[0]) != 0 and es.getplayername(split_key[1]) != 0:
            count += 1
            dom_popup.addline('->' + str(count) + '. ' + es.getplayername(split_key[1]) + ' dominating ' + es.getplayername(split_key[0]) + ' ' + str(domination_counts[key]) + ' times')
            if count == dom_popup_top_value:
                break
    
    if count == 0:
        dom_popup.addline('No dominations')
    
    for ply in es.getUseridList():
        if not ply in hidden.keys():
            dom_popup.send(ply)
            gamethread.delayed(5.0, dom_popup.unsend, ply)

def show_best_dominations():
    global hidden
    global dom_popup
    global domination_records
    
    if popuplib.exists('dom_popup'):
        popuplib.delete('dom_popup')
    
    dom_popup = popuplib.create('dom_popup')
    dom_popup.addline("Best Dominations")
    dom_popup.addline(" ")
    
    key_list = getsortkey(domination_records)
    count = 0
    for key in key_list:
        split_key = key.split('<')
        if domination_records[key] >= first_range:
            if es.getplayername(split_key[0]) != 0 and es.getplayername(split_key[1]) != 0:
                count += 1
                dom_popup.addline('->' + str(count) + '. ' + str(domination_records[key]) + ' (' + es.getplayername(split_key[1]) + ' dominating ' + es.getplayername(split_key[0]) + ')')
                if count == dom_popup_top_value:
                    break

    if count == 0:
        dom_popup.addline('No dominations')
    
    for ply in es.getUseridList():
        if not ply in hidden.keys():
            dom_popup.send(ply)
            gamethread.delayed(5.0, dom_popup.unsend, ply)

def getsortkey(d):
    rev_items = [(v,k) for k, v in d.items()]
    rev_items.sort(reverse=True)
    return [k for (v,k) in rev_items]    

def hide_popups():
    global hidden
    user = es.getcmduserid()
    es.tell(user, "#multi", "#green[DOM]#default You are now hiding dominating popups.")
    es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_popup_show_cmd + " to unhide the dominating popups.")
    hidden[user] = 1

def show_popups():
    global hidden
    user = es.getcmduserid()
    es.tell(user, "#multi", "#green[DOM]#default You are now unhiding dominating popups.")
    es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_popup_hide_cmd + " to hide the dominating popups.")
    if user in hidden.keys():
        del hidden[user]

if dom_use_sounds:
    def mute_sounds():
        global muted
        user = es.getcmduserid()
        es.tell(user, "#multi", "#green[DOM]#default You are now muting dominating sounds.")
        es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_sound_unmute_cmd + " to unmute to dominating sounds.")
        muted[user] = 1
    
    def unmute_sounds():
        global muted
        user = es.getcmduserid()
        es.tell(user, "#multi", "#green[DOM]#default You are now unmuting dominating sounds.")
        es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_sound_mute_cmd + " to mute to dominating sounds.")
        if user in muted.keys():
            del muted[user]    
